//Core is a wrapper class created by Brent Cowan (freegadgets@hotmail.com) to
//simplify GLFW windowing code. This wrapper reduces the amount of code needed to control a window 
//and recieve input from the keyboard and mouse.
//Last revision: May 2010

#include "GLFW/IncludesGLFW.h"

#pragma comment(lib, "Gadget/Gadget3D.lib")

#include "Extensions.h"
#include "FunctionsAndConstants.h"
#include "Frustum.h"

//Managers
#include "WindowManager.h"
#include "KeyboardManager.h"
#include "TimeManager.h"
#include "MouseManager.h"
#include "JoystickManager.h"
#include "RenderingManager.h"

#ifndef _EngineCore_
#define _EngineCore_

//#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

class DECLDIR Core
{
private:
	bool init;

public:
	Core();
	~Core();

	static WindowManager    Window;
	static TimeManager      Timer;
	static RenderingManager Renderer;
	static KeyboardManager  Keyboard;
	static MouseManager     Mouse;
	static JoystickManager  Joystick;
};


#endif	