//Brent Cowan Aug. 2008

#ifndef _SoundEngine_
#define _SoundEngine_

#pragma comment(lib, "Gadget/FMod/fmodex_vc.lib")

#include "fmod.hpp"
#include "fmod_errors.h"

class listenerClass
{
public:
	listenerClass();

	FMOD_VECTOR position, velocity;
	FMOD_VECTOR lastPos;
    FMOD_VECTOR forward;
    FMOD_VECTOR up;
};

class SoundEngine
{
private:
	FMOD_RESULT      result;
	unsigned int     version;
    FMOD_SPEAKERMODE speakermode;
	FMOD_CAPS        caps;
	char             name[256];

public:
	SoundEngine();
	~SoundEngine();
	void ERRCHECK(FMOD_RESULT result);
	void Update(float ElapsedTime);

	listenerClass    listener;
	float            DISTANCEFACTOR;       //Units per meter.  I.e feet would = 3.28.  centimeters would = 100.
	FMOD::System*    system;
};


class Sound
{
private:
	SoundEngine* S;
	bool init;
	FMOD_RESULT result;
	bool is3D;
	FMOD_VECTOR position, velocity;
	float minDistance, maxDistance;

public:
	Sound();
	~Sound();
	bool Load(char *FileName, SoundEngine* engine, bool is3D, bool isLooping);
	void Play();
	void Stop();
	void Set3dPosition(float x, float y, float z);
	FMOD_VECTOR Get3dPosition();
	void Set3dVelocity(float x, float y, float z);
	FMOD_VECTOR Get3dVelocity();
	void SetMinMaxDistance(float min, float max);

	FMOD::Sound*   soundFile;
    FMOD::Channel* channel;		
};

#endif