//Brent Cowan Dec 2009

#include "GLFW/IncludesGLFW.h"
#include "Extensions.h"
#include "Font.h"


Font::Font()
{
	fontSize = 12.0f;
}

Font::~Font()
{
	glDeleteLists(base, 100);							// Delete All 256 Characters
}

bool Font::Load(HDC hdc, char *fontName)
{
	//float planeCoefficients[4]  = {1.23f, 0.0f, 0.0f, 0.0f};
	//float planeCoefficients2[4] = {0.0f, 1.23f, 0.0f, 0.25f};

	////Create Texture coordinates
	//glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	//glTexGenfv(GL_S, GL_OBJECT_PLANE, planeCoefficients);
	//	
	//glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
	//glTexGenfv(GL_T, GL_OBJECT_PLANE, planeCoefficients2);
	

	HFONT	font;										// Windows Font ID

	base = glGenLists(100);								// Storage For 256 Characters

	font = CreateFont(	-12,							// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						fontName);				        // Font Name

	SelectObject(hdc, font);							// Selects The Font We Created

	wglUseFontOutlines(	hdc,							// Select The Current DC
						32,								// Starting Character
						100,							// Number Of Display Lists To Build
						base,							// Starting Display Lists
						0.01f,							// Deviation From The True Outlines
						0.0f,							// Font Thickness In The Z Direction
						WGL_FONT_POLYGONS,				// Use Polygons, Not Lines
						gmf);							// Address Of Buffer To Recieve Data

	return (font>0);
}

void Font::Render(float x, float y, string message)			// Custom GL "Print" Routine
{
	glPushMatrix();
	
	glTranslatef(x, y, 0.0f);					        // Center Our Text On The Screen
	glScalef(fontSize, fontSize, 1.0f);

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base-32);									// Sets The Base Character to 0

	glCallLists(int(message.size()), GL_UNSIGNED_BYTE, message.c_str());	// Draws The Display List Text
	
	glPopAttrib();										// Pops The Display List Bits
	glPopMatrix();
}

float Font::GetLength(string message)
{
	float length = 0.0f;			  				   // Used To Find The Length Of The Text
	
	for (unsigned int i = 0; i<(message.size()); i++)  // Loop To Find Text Length
	{
		length += gmf[message.c_str()[i]-32].gmfCellIncX; // Increase Length By Each Characters Width
	}
	return length * fontSize;
}

float Font::GetCharWidth(unsigned char character)
{
	return gmf[character-32].gmfCellIncX * fontSize;
}