//Brent Cowan Jan 2007

#ifndef _ViewFrustum_
#define _ViewFrustum_

//#define DLL_EXPORT
#if defined DLL_EXPORT
#define DECLDIR __declspec(dllexport)
#else
#define DECLDIR __declspec(dllimport)
#endif

struct DECLDIR plane_t
{
  GLfloat A, B, C, D;
};

union DECLDIR frustum_t
{
  struct
  {
    plane_t t, b, l, r, n, f;
  };
  plane_t planes[6];
};

// extract a plane from a given matrix and row id
void DECLDIR ExtractPlane(plane_t &plane, GLfloat *mat, int row);

bool DECLDIR SphereInFrustum(Vector3D center, GLfloat radius, frustum_t frustum);

class DECLDIR ViewFrustum
{
public:
	void Step();
	bool FrustumCheck(Vector3D center, GLfloat radius);

	frustum_t frustum;
};

#endif