#ifndef _TextBox_
#define _TextBox_

#include "Font.h"
#include <vector>

struct Row
{
	string text;
	unsigned short firstChar;
	float width;
};

class TextBox
{
private:
	void     CalculateWordWrap();

	bool     init;
	vector<Row> rows;
	bool     flagChange;
	float    scale;
	float    width;
	float    height;
	string   text;
	bool     center;

public:
	TextBox();
	~TextBox();

	bool   Init(Core* G, Font* font, float width, float height);
	void   Render();
	void   Step();
	bool   PointOnText(Vector2D point);
	void   AlignCenter();
	void   AlignRight();

	void   AddText(string text);
	void   AddNewLine();
	float  GetHeight();
	float  GetScale();
	string GetText();
	float  GetWidth();
	void   SetHeight(float height);
	void   SetScale(float scale);
	void   SetText(string text);
	void   SetText(char *text);
	void   SetWidth(float width);

	Font*    font;
	Vector2D position;
	bool     editable;
	bool     erase;
	unsigned short maxLength;

	static Core* G;
};

#endif